=== debian/changelog ===
lucene++ (3.0.4-0ubuntu3) trusty; urgency=low

  * No change rebuild against Boost 1.54.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Sun, 27 Oct 2013 02:15:20 +0000

lucene++ (3.0.4-0ubuntu2) saucy; urgency=low

  * Remove debian/patches/add_cross_build.diff:
    - It seems we don't need this currently
  * debian/rules:
    - Remove cross-building changes
    - Build using the standard allocator (-DENABLE_STANDARD_ALLOCATOR:BOOL=ON)
  * debian/control:
    - Developer packages depend on -doc
    - Enable multi-arch
    - Minor enhancements
  * Add debian/patches/enable_multiarch.diff:
    - Patch fixing some paths for proper multiarch support

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Thu, 01 Aug 2013 12:38:42 +0200

lucene++ (3.0.4-0ubuntu1) saucy; urgency=low

  * Initial release based on the packaging made by Mathias Hasselmann and
    Ken VanDine
  * Import Ricardo Salveti's package cross-build modifications with slight
    modifications

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Tue, 30 Jul 2013 15:00:47 +0200
