=== debian/watch ===
version=3
http://githubredir.debian.net/github/luceneplusplus/LucenePlusPlus .*/rel_(.+)\.tar\.gz
