=== debian/changelog ===
lucene++ (3.0.6-3) unstable; urgency=medium

  * Do not symlink jquery from doxygen, this will result in a
    broken documentation. cfr: 736360.
    - Drop libjs-jquery and dh-linktree from b-d.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Thu, 30 Oct 2014 12:03:59 +0100

lucene++ (3.0.6-2) unstable; urgency=medium

  * debian/patches/fix-build-failure.patch
    - trying to fix both hurd and kfreebsd-* build failures.
  * Bump std-version to 3.9.6, no changes required.
  * Fix some copyright entries.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Fri, 10 Oct 2014 19:25:22 +0200

lucene++ (3.0.6-1) unstable; urgency=low

  * Initial release (Closes: #750148).

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Mon, 16 Jun 2014 17:48:23 +0200
