=== debian/control ===
Source: lucene++
Priority: optional
Maintainer: Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>
Uploaders: Gianfranco Costamagna <costamagnagianfranco@yahoo.it>
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev
Build-Depends-Indep: doxygen
Standards-Version: 3.9.6
Section: libs
Homepage: https://github.com/luceneplusplus/LucenePlusPlus

Package: liblucene++-dev
Section: libdevel
Architecture: any
Depends: liblucene++-contrib0 (= ${binary:Version}),
         liblucene++0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Development files for Lucene++
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This package contains development files.

Package: liblucene++-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Reference manual for Lucene++
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This package contains the reference manual and examples.

Package: liblucene++0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Shared library for Lucene++
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This package contains the shared library.

Package: liblucene++-contrib0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Shared library with Lucene++ contributions
 Lucene++ is an up to date C++ port of the popular Java Lucene
 library, a high-performance, full-featured text search engine.
 .
 This additional contributions include analyzers, a memory-only
 index and a HTML highlighter for search results.
