=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ -- --parallel --fail-missing

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_STANDARD_ALLOCATOR:BOOL=ON

override_dh_auto_build-indep:
	dh_auto_configure -- -DENABLE_STANDARD_ALLOCATOR:BOOL=ON -DENABLE_DOCS:BOOL=ON
	dh_auto_build -- doc

override_dh_install-indep:
	dh_install -pliblucene++-doc usr/share/doc/lucene++-3.0.6/* usr/share/doc/liblucene++-doc/html
	rm -rf debian/tmp/usr/share/doc/lucene++-3.0.6/
